﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PatrolBehaviour : MonoBehaviour {

    private int currentIdx;
    public Transform[] patrolPointList;
    public float speed = 0.005f;

    void Start()
    {
        currentIdx = 0;
        GotoNextPoint();
    }

    void GotoNextPoint()
    {
        if (patrolPointList.Length == 0)
            return;

        currentIdx = (currentIdx + 1) % patrolPointList.Length;
    }

    void ApproachPoint()
    {
        float step = speed * Time.deltaTime;
        Transform target = patrolPointList[currentIdx];
        transform.position = Vector3.MoveTowards(transform.position, target.position, step);
    }

    // Update is called once per frame
    void Update()
    {
        if (patrolPointList.Length == 0)
            return;
        Vector3 v = (transform.position - patrolPointList[currentIdx].position);
        // Debug.Log("------- " + v + "   magnitude: " + v.magnitude + "   magnitude sqrt: " + v.sqrMagnitude);
        if (v.magnitude < 0.005f)
        {
            GotoNextPoint();
            if (!gameObject.name.Contains("eroid"))
            {
                Vector3 dir = patrolPointList[currentIdx].position - transform.position;
                float angle = Mathf.Atan2(dir.y, dir.x) * Mathf.Rad2Deg;
                transform.rotation = Quaternion.AngleAxis(angle, Vector3.forward);
            }
        }
        else
        {
            ApproachPoint();
        }
    }

}
